// pages/task/task.js
import {
  taskList,
  getReward,
  getResume
} from '../../../../services/index.js';

Page({

  /**
   * 页面的初始数据
   */
  data: {
    hpUserResumeId: 0
  },
  /**
   * 获取任务列表
   */
  task() {
    taskList({
      user_id: wx.getStorageSync('user_id'),
      user_token: wx.getStorageSync('user_token'),
      member_id: wx.getStorageSync('member_id')
    }).then(res => {
      if (res.errcode === 0) {
        this.setData(res.data)
      }
    })
  },
  /* 
    领取奖励
    @taskId 任务ID
    @taskType 任务类型（0：新手任务 1：日常任务）
   */
  reward(e) {
    const {
      id,
      type,
      index,
      points
    } = e.currentTarget.dataset;
    const _params = Object.assign({
      user_id: wx.getStorageSync('user_id'),
      user_token: wx.getStorageSync('user_token'),
      member_id: wx.getStorageSync('member_id'),
    }, {
      taskId: id,
      taskType: type
    })
    getReward(_params).then(res => {
      if (res.errcode === 0) {
        const list = type === '0' ? `new_task[${index}].is_get` : `day_task[${index}].is_get`;
        // const arr = this.data[list];
        // arr[index].is_get = true;
        this.setData({
          [list]: true
        })
        wx.showToast({
          icon: 'none',
          title: `领取成功 积分+${points}`,
        })
      }
    })
  },
  /**
   * 跳转页面去岗位列表
   */
  toDetail() {
    wx.navigateTo({
      url: '/pages/fulltime/index',
    })
  },
  /* 
    新手任务
    根据不同的ID到不同的任务页面
   */
  newToDetail(e) {
    const id = e.currentTarget.dataset.id;
    if (id === '3') {
      if (this.data.hpUserResumeId) {
        wx.navigateTo({
          url: '../jianli/index?hpUserResumeId=' + this.data.hpUserResumeId,
        })
      } else {
        wx.navigateTo({
          url: '../user-info/user-info',
        })
      }
    } else if (id === '2') {
      wx.navigateTo({
        url: '/pages/identification/index',
      })
    } else {
      wx.navigateTo({
        url: '/pages/fulltime/index',
      })
    }
  },
  /**
   * 获取用户简历详情
   */
  getUserResume() {
    let paramsObj = {
      user_id: wx.getStorageSync('user_id'),
      user_token: wx.getStorageSync('user_token'),
      member_id: wx.getStorageSync('member_id'),
    }
    getResume(paramsObj).then(data => {
      if (data.data.userResume) {
        this.setData({
          hpUserResumeId: data.data.userResume.id,
        })
      }
    })
  },
  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function(options) {

  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function() {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function() {
    // 获取任务列表
    this.task()
    this.getUserResume()
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function() {

  },
})